# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with          maven

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/apache/ws/commons/axiom/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define _without_gcj_support 1
%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define section free

Name:           ws-commons-axiom
Version:        1.2.7
Release:        3%{?dist}
Epoch:          0
Summary:        AXIOM XML infoset model for Apache Axis2
License:        ASL 2.0
URL:            http://ws.apache.org/commons/axiom/
Group:          Text Processing/Markup/XML
# svn export http://svn.apache.org/repos/asf/webservices/commons/tags/axiom/1.2.7/ ws-commons-axiom-1.2.7
# tar cvjf ws-commons-axiom-1.2.7.tar.bz2 ws-commons-axiom-1.2.7
Source0:        ws-commons-axiom-%{version}.tar.bz2
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-build.xml
Source4:        %{name}-modules-axiom-api-build.xml
Source5:        %{name}-modules-axiom-dom-build.xml
Source6:        %{name}-modules-axiom-impl-build.xml
Source7:	%{name}-component-info.xml
Source8:	%{name}-upload.sh
BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  ant >= 0:1.6
BuildRequires:  junit >= 0:3.8.2
%if %with maven
BuildRequires:  maven2 >= 2.0.4-10jpp
BuildRequires:  mojo-maven2-plugin-jdepend
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-one
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven2-default-skin
%endif
%if %{gcj_support}
BuildRequires:    java-gcj-compat-devel
%endif
BuildRequires:  geronimo-specs-poms
BuildRequires:  geronimo-stax-1.0-api
BuildRequires:  geronimo-javamail-1.4-api
BuildRequires:  geronimo-jaf-1.1-api
BuildRequires:  jakarta-commons-logging
BuildRequires:  jaxen
BuildRequires:  jdepend
BuildRequires:  wstx >= 0:3.1.1
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  xmlunit
# To create content for maven2-brew
BuildRequires:  maven-deploy-plugin

Requires(post):    jpackage-utils >= 0:1.7.2
Requires(postun):  jpackage-utils >= 0:1.7.2
Requires:       stax_1_0_api
Requires:       xml-commons-jaxp-1.3-apis
Requires:       javamail = 0:1.4
Requires:       jaf = 0:1.1
Requires:       jakarta-commons-logging
Requires:       jaxen
Requires:       wstx >= 0:3.1.1
Requires:       xerces-j2
Obsoletes:      apache-axiom < %{epoch}:%{version}-%{release}
Provides:       apache-axiom = %{epoch}:%{version}-%{release}
%if ! %{gcj_support}
BuildArch:      noarch
%endif

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
AXIOM stands for AXis Object Model (also known as OM - Object Model)
and refers to the XML infoset model that is initialy developed for
Apache Axis2.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Obsoletes:      apache-axiom-javadoc = 0:1.0
Provides:       apache-axiom-javadoc = %{epoch}:%{version}-%{release}

%description javadoc
%{summary}.

%if %with maven
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
cp -p %{SOURCE1} settings.xml

# fix eol
%{__perl} -pi -e 's/\r$//g' README.txt NOTICE.txt RELEASE-NOTE.txt

rm -f src/site/xdoc/download.*
cp -p %{SOURCE3} build.xml
cp -p %{SOURCE4} modules/axiom-api/build.xml
cp -p %{SOURCE5} modules/axiom-dom/build.xml
cp -p %{SOURCE6} modules/axiom-impl/build.xml

mkdir modules/axiom-api/src/site
cp -p src/site/site.xml modules/axiom-api/src/site
mkdir modules/axiom-dom/src/site
cp -p src/site/site.xml modules/axiom-dom/src/site
mkdir modules/axiom-impl/src/site
cp -p src/site/site.xml modules/axiom-impl/src/site

%build
mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%if %with maven
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

export MAVEN_SETTINGS=$(pwd)/settings.xml
mvn-jpp -e -s ${MAVEN_SETTINGS} -Dmaven2.jpp.depmap.file=%{SOURCE2} -Dmaven.repo.local=$MAVEN_REPO_LOCAL install javadoc:javadoc site

pushd modules/axiom-tests
    mvn-jpp -e -s ${MAVEN_SETTINGS} -Dmaven2.jpp.depmap.file=%{SOURCE2} -Dmaven.repo.local=$MAVEN_REPO_LOCAL install
popd
%else
export OPT_JAR_LIST=:
export CLASSPATH=$(build-classpath \
commons-logging \
jaxen \
geronimo-javamail-1.4-api \
geronimo-jaf-1.1-api \
xml-commons-jaxp-1.3-apis \
geronimo-stax-1.0-api \
)
pushd modules/axiom-api
ant -Dbuild.sysclasspath=only jar test javadoc
popd
AXIOM_API_JAR=`ls $(pwd)/modules/axiom-api/target/axiom-api-*.jar`
CLASSPATH=$CLASSPATH:${AXIOM_API_JAR}
pushd modules/axiom-impl
ant -Dbuild.sysclasspath=only jar test javadoc
popd
AXIOM_IMPL_JAR=`ls $(pwd)/modules/axiom-impl/target/axiom-impl-*.jar`
CLASSPATH=$CLASSPATH:${AXIOM_IMPL_JAR}
pushd modules/axiom-dom
ant -Dbuild.sysclasspath=only jar test javadoc
popd

# Yes, create target
mkdir target
%endif

mkdir tmp
pushd tmp
%{jar} xf ../modules/axiom-impl/target/axiom-impl-*.jar
%{jar} xf ../modules/axiom-dom/target/axiom-dom-*.jar
%{jar} xf ../modules/axiom-api/target/axiom-api-*.jar
%{jar} cf ../target/axiom-%{version}.jar *
popd
rm -rf tmp

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -m 644 target/axiom-*.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 modules/axiom-api/target/axiom-api-*.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-api-%{version}.jar
install -m 644 modules/axiom-impl/target/axiom-impl-*.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-impl-%{version}.jar
install -m 644 modules/axiom-dom/target/axiom-dom-*.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-dom-%{version}.jar
%add_to_maven_depmap org.apache.ws.commons.axiom axiom %{version} JPP %{name}
%add_to_maven_depmap org.apache.ws.commons.axiom axiom-api %{version} JPP %{name}-api
%add_to_maven_depmap org.apache.ws.commons.axiom axiom-dom %{version} JPP %{name}-dom
%add_to_maven_depmap org.apache.ws.commons.axiom axiom-impl %{version} JPP %{name}-impl
# create unprefixed and unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}
for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done
)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom
install -pm 644 modules/axiom-api/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-api.pom
install -pm 644 modules/axiom-dom/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-dom.pom
install -pm 644 modules/axiom-impl/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-impl.pom

# javadocs
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/api
cp -pr modules/axiom-api/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/api
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/dom
cp -pr modules/axiom-dom/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/dom
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/impl
cp -pr modules/axiom-impl/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/impl
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
%if %with maven
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %with repolib
%{__install} -d -m 755 %{buildroot}%{repodir}
%{__install} -d -m 755 %{buildroot}%{repodirlib}
%{__install} -p -m 644 %{SOURCE7} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml

%{__install} -d -m 755 %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE3} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE4} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE5} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE6} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/%{name}.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}-api-%{version}.jar %{buildroot}%{repodirlib}/%{name}-api.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}-impl-%{version}.jar %{buildroot}%{repodirlib}/%{name}-impl.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}-dom-%{version}.jar %{buildroot}%{repodirlib}/%{name}-dom.jar
%{__install} -p -m 644 pom.xml %{buildroot}%{repodirlib}/%{name}.pom
%{__install} -p -m 644 modules/axiom-api/pom.xml %{buildroot}%{repodirlib}/%{name}-api.pom
%{__install} -p -m 644 modules/axiom-impl/pom.xml %{buildroot}%{repodirlib}/%{name}-impl.pom
%{__install} -p -m 644 modules/axiom-dom/pom.xml %{buildroot}%{repodirlib}/%{name}-dom.pom
%{__install} -p -m 755 %{SOURCE8} %{buildroot}%{repodir}/upload.sh
pushd %{buildroot}%{repodir}
./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
popd
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc *.txt
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-api-%{version}.jar
%{_javadir}*/%{name}-api.jar
%{_javadir}*/%{name}-dom-%{version}.jar
%{_javadir}*/%{name}-dom.jar
%{_javadir}*/%{name}-impl-%{version}.jar
%{_javadir}*/%{name}-impl.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with maven
%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Dec 15 2010 Hui Wang <huwang@redhat.com> 0:1.2.7-3
- Add upload.sh and content of maven2-brew to repolib
- Fix %%files for signed jars
`
* Wed Jun 30 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.2.7-2.3
- Rebuild for EAP 5.1

* Thu Feb 2 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.2.7-2.2.1
- Disable aot Compiler

* Thu Jul 30 2009 Martha Benitez <mbenitez@redhat.com> 0:1.2.7-2.2
- Add repolib

* Tue Jul 28 2009 Martha Benitez <mbenitez@redhat.com> 0:1.2.7-2.1
- Change BR maven-surefire-plugin to maven-surefire-maven-plugin

* Mon Aug 04 2008 David Walluck <dwalluck@redhat.com> 0:1.2.7-2
- install .pom files even when building with ant
- remove unused patches

* Mon Aug 04 2008 David Walluck <dwalluck@redhat.com> 0:1.2.7-1
- 1.2.7

* Tue Jul 29 2008 David Walluck <dwalluck@redhat.com> 0:1.2.4-3
- use glassfish instead of sun
- fix Summary
- use jar macro

* Sat Jul 26 2008 David Walluck <dwalluck@redhat.com> 0:1.2.4-2
- remove javadoc scriptlets
- remove Vendor and Distribution
- update License
- update BuildRoot
- fix maven dependencies
- fix maven directory ownership
- fix %%doc
- GCJ fixes

* Wed May 30 2007 Ralph Apel <r.apel at r-apel.de> 0:1.2.4-1jpp
- Upgrade to 1.2.4
- Switch to maven2 build by default
- Optionally build with straight ant
- Add gcj_support option
- Install poms and depmap frags
- Make Vendor, Distribution based on macro

* Fri May 05 2006 Ralph Apel <r.apel at r-apel.de> 0:1.0-1jpp
- Initial build.
